// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosgraph_monitor_msgs:msg/TopicStatistic.idl
// generated code does not contain a copyright notice
#include "rosgraph_monitor_msgs/msg/detail/topic_statistic__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `node_name`
// Member `topic_name`
#include "rosidl_runtime_c/string_functions.h"
// Member `mean`
// Member `min`
// Member `max`
#include "builtin_interfaces/msg/detail/duration__functions.h"

bool
rosgraph_monitor_msgs__msg__TopicStatistic__init(rosgraph_monitor_msgs__msg__TopicStatistic * msg)
{
  if (!msg) {
    return false;
  }
  // statistic_type
  // node_name
  if (!rosidl_runtime_c__String__init(&msg->node_name)) {
    rosgraph_monitor_msgs__msg__TopicStatistic__fini(msg);
    return false;
  }
  // topic_name
  if (!rosidl_runtime_c__String__init(&msg->topic_name)) {
    rosgraph_monitor_msgs__msg__TopicStatistic__fini(msg);
    return false;
  }
  // window_count
  // mean
  if (!builtin_interfaces__msg__Duration__init(&msg->mean)) {
    rosgraph_monitor_msgs__msg__TopicStatistic__fini(msg);
    return false;
  }
  // min
  if (!builtin_interfaces__msg__Duration__init(&msg->min)) {
    rosgraph_monitor_msgs__msg__TopicStatistic__fini(msg);
    return false;
  }
  // max
  if (!builtin_interfaces__msg__Duration__init(&msg->max)) {
    rosgraph_monitor_msgs__msg__TopicStatistic__fini(msg);
    return false;
  }
  return true;
}

void
rosgraph_monitor_msgs__msg__TopicStatistic__fini(rosgraph_monitor_msgs__msg__TopicStatistic * msg)
{
  if (!msg) {
    return;
  }
  // statistic_type
  // node_name
  rosidl_runtime_c__String__fini(&msg->node_name);
  // topic_name
  rosidl_runtime_c__String__fini(&msg->topic_name);
  // window_count
  // mean
  builtin_interfaces__msg__Duration__fini(&msg->mean);
  // min
  builtin_interfaces__msg__Duration__fini(&msg->min);
  // max
  builtin_interfaces__msg__Duration__fini(&msg->max);
}

bool
rosgraph_monitor_msgs__msg__TopicStatistic__are_equal(const rosgraph_monitor_msgs__msg__TopicStatistic * lhs, const rosgraph_monitor_msgs__msg__TopicStatistic * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // statistic_type
  if (lhs->statistic_type != rhs->statistic_type) {
    return false;
  }
  // node_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->node_name), &(rhs->node_name)))
  {
    return false;
  }
  // topic_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->topic_name), &(rhs->topic_name)))
  {
    return false;
  }
  // window_count
  if (lhs->window_count != rhs->window_count) {
    return false;
  }
  // mean
  if (!builtin_interfaces__msg__Duration__are_equal(
      &(lhs->mean), &(rhs->mean)))
  {
    return false;
  }
  // min
  if (!builtin_interfaces__msg__Duration__are_equal(
      &(lhs->min), &(rhs->min)))
  {
    return false;
  }
  // max
  if (!builtin_interfaces__msg__Duration__are_equal(
      &(lhs->max), &(rhs->max)))
  {
    return false;
  }
  return true;
}

bool
rosgraph_monitor_msgs__msg__TopicStatistic__copy(
  const rosgraph_monitor_msgs__msg__TopicStatistic * input,
  rosgraph_monitor_msgs__msg__TopicStatistic * output)
{
  if (!input || !output) {
    return false;
  }
  // statistic_type
  output->statistic_type = input->statistic_type;
  // node_name
  if (!rosidl_runtime_c__String__copy(
      &(input->node_name), &(output->node_name)))
  {
    return false;
  }
  // topic_name
  if (!rosidl_runtime_c__String__copy(
      &(input->topic_name), &(output->topic_name)))
  {
    return false;
  }
  // window_count
  output->window_count = input->window_count;
  // mean
  if (!builtin_interfaces__msg__Duration__copy(
      &(input->mean), &(output->mean)))
  {
    return false;
  }
  // min
  if (!builtin_interfaces__msg__Duration__copy(
      &(input->min), &(output->min)))
  {
    return false;
  }
  // max
  if (!builtin_interfaces__msg__Duration__copy(
      &(input->max), &(output->max)))
  {
    return false;
  }
  return true;
}

rosgraph_monitor_msgs__msg__TopicStatistic *
rosgraph_monitor_msgs__msg__TopicStatistic__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosgraph_monitor_msgs__msg__TopicStatistic * msg = (rosgraph_monitor_msgs__msg__TopicStatistic *)allocator.allocate(sizeof(rosgraph_monitor_msgs__msg__TopicStatistic), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosgraph_monitor_msgs__msg__TopicStatistic));
  bool success = rosgraph_monitor_msgs__msg__TopicStatistic__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosgraph_monitor_msgs__msg__TopicStatistic__destroy(rosgraph_monitor_msgs__msg__TopicStatistic * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosgraph_monitor_msgs__msg__TopicStatistic__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosgraph_monitor_msgs__msg__TopicStatistic__Sequence__init(rosgraph_monitor_msgs__msg__TopicStatistic__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosgraph_monitor_msgs__msg__TopicStatistic * data = NULL;

  if (size) {
    data = (rosgraph_monitor_msgs__msg__TopicStatistic *)allocator.zero_allocate(size, sizeof(rosgraph_monitor_msgs__msg__TopicStatistic), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosgraph_monitor_msgs__msg__TopicStatistic__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosgraph_monitor_msgs__msg__TopicStatistic__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosgraph_monitor_msgs__msg__TopicStatistic__Sequence__fini(rosgraph_monitor_msgs__msg__TopicStatistic__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosgraph_monitor_msgs__msg__TopicStatistic__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosgraph_monitor_msgs__msg__TopicStatistic__Sequence *
rosgraph_monitor_msgs__msg__TopicStatistic__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosgraph_monitor_msgs__msg__TopicStatistic__Sequence * array = (rosgraph_monitor_msgs__msg__TopicStatistic__Sequence *)allocator.allocate(sizeof(rosgraph_monitor_msgs__msg__TopicStatistic__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosgraph_monitor_msgs__msg__TopicStatistic__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosgraph_monitor_msgs__msg__TopicStatistic__Sequence__destroy(rosgraph_monitor_msgs__msg__TopicStatistic__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosgraph_monitor_msgs__msg__TopicStatistic__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosgraph_monitor_msgs__msg__TopicStatistic__Sequence__are_equal(const rosgraph_monitor_msgs__msg__TopicStatistic__Sequence * lhs, const rosgraph_monitor_msgs__msg__TopicStatistic__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosgraph_monitor_msgs__msg__TopicStatistic__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosgraph_monitor_msgs__msg__TopicStatistic__Sequence__copy(
  const rosgraph_monitor_msgs__msg__TopicStatistic__Sequence * input,
  rosgraph_monitor_msgs__msg__TopicStatistic__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosgraph_monitor_msgs__msg__TopicStatistic);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rosgraph_monitor_msgs__msg__TopicStatistic * data =
      (rosgraph_monitor_msgs__msg__TopicStatistic *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosgraph_monitor_msgs__msg__TopicStatistic__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rosgraph_monitor_msgs__msg__TopicStatistic__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosgraph_monitor_msgs__msg__TopicStatistic__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
