// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rosgraph_monitor_msgs:msg/TopicStatistic.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rosgraph_monitor_msgs/msg/topic_statistic.h"


#ifndef ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTIC__STRUCT_H_
#define ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTIC__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'PUBLISHED_PERIOD'.
enum
{
  rosgraph_monitor_msgs__msg__TopicStatistic__PUBLISHED_PERIOD = 0
};

/// Constant 'RECEIVED_PERIOD'.
/**
  * inverse of frequency
 */
enum
{
  rosgraph_monitor_msgs__msg__TopicStatistic__RECEIVED_PERIOD = 1
};

/// Constant 'TAKE_AGE'.
/**
  * the system time difference between DDS publish and rmw_take
 */
enum
{
  rosgraph_monitor_msgs__msg__TopicStatistic__TAKE_AGE = 2
};

// Include directives for member types
// Member 'node_name'
// Member 'topic_name'
#include "rosidl_runtime_c/string.h"
// Member 'mean'
// Member 'min'
// Member 'max'
#include "builtin_interfaces/msg/detail/duration__struct.h"

/// Struct defined in msg/TopicStatistic in the package rosgraph_monitor_msgs.
/**
  * Statistics about one measurement for a single endpoint of a topic
 */
typedef struct rosgraph_monitor_msgs__msg__TopicStatistic
{
  /// one of above constants
  uint8_t statistic_type;
  /// name of the node holding the endpoint (publisher or subscription)
  rosidl_runtime_c__String node_name;
  /// topic being measured
  rosidl_runtime_c__String topic_name;
  /// how many messages were in the calculation
  int32_t window_count;
  builtin_interfaces__msg__Duration mean;
  builtin_interfaces__msg__Duration min;
  builtin_interfaces__msg__Duration max;
} rosgraph_monitor_msgs__msg__TopicStatistic;

// Struct for a sequence of rosgraph_monitor_msgs__msg__TopicStatistic.
typedef struct rosgraph_monitor_msgs__msg__TopicStatistic__Sequence
{
  rosgraph_monitor_msgs__msg__TopicStatistic * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rosgraph_monitor_msgs__msg__TopicStatistic__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTIC__STRUCT_H_
