// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rosgraph_monitor_msgs:msg/TopicStatistic.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rosgraph_monitor_msgs/msg/topic_statistic.hpp"


#ifndef ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTIC__TRAITS_HPP_
#define ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTIC__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rosgraph_monitor_msgs/msg/detail/topic_statistic__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'mean'
// Member 'min'
// Member 'max'
#include "builtin_interfaces/msg/detail/duration__traits.hpp"

namespace rosgraph_monitor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const TopicStatistic & msg,
  std::ostream & out)
{
  out << "{";
  // member: statistic_type
  {
    out << "statistic_type: ";
    rosidl_generator_traits::value_to_yaml(msg.statistic_type, out);
    out << ", ";
  }

  // member: node_name
  {
    out << "node_name: ";
    rosidl_generator_traits::value_to_yaml(msg.node_name, out);
    out << ", ";
  }

  // member: topic_name
  {
    out << "topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.topic_name, out);
    out << ", ";
  }

  // member: window_count
  {
    out << "window_count: ";
    rosidl_generator_traits::value_to_yaml(msg.window_count, out);
    out << ", ";
  }

  // member: mean
  {
    out << "mean: ";
    to_flow_style_yaml(msg.mean, out);
    out << ", ";
  }

  // member: min
  {
    out << "min: ";
    to_flow_style_yaml(msg.min, out);
    out << ", ";
  }

  // member: max
  {
    out << "max: ";
    to_flow_style_yaml(msg.max, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TopicStatistic & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: statistic_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "statistic_type: ";
    rosidl_generator_traits::value_to_yaml(msg.statistic_type, out);
    out << "\n";
  }

  // member: node_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "node_name: ";
    rosidl_generator_traits::value_to_yaml(msg.node_name, out);
    out << "\n";
  }

  // member: topic_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.topic_name, out);
    out << "\n";
  }

  // member: window_count
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "window_count: ";
    rosidl_generator_traits::value_to_yaml(msg.window_count, out);
    out << "\n";
  }

  // member: mean
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mean:\n";
    to_block_style_yaml(msg.mean, out, indentation + 2);
  }

  // member: min
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min:\n";
    to_block_style_yaml(msg.min, out, indentation + 2);
  }

  // member: max
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max:\n";
    to_block_style_yaml(msg.max, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TopicStatistic & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rosgraph_monitor_msgs

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rosgraph_monitor_msgs::msg::TopicStatistic>()
{
  return "rosgraph_monitor_msgs::msg::TopicStatistic";
}

template<>
inline const char * name<rosgraph_monitor_msgs::msg::TopicStatistic>()
{
  return "rosgraph_monitor_msgs/msg/TopicStatistic";
}

template<>
struct has_fixed_size<rosgraph_monitor_msgs::msg::TopicStatistic>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rosgraph_monitor_msgs::msg::TopicStatistic>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rosgraph_monitor_msgs::msg::TopicStatistic>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTIC__TRAITS_HPP_
