// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rosgraph_monitor_msgs:msg/TopicStatistics.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rosgraph_monitor_msgs/msg/topic_statistics.hpp"


#ifndef ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTICS__TRAITS_HPP_
#define ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTICS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rosgraph_monitor_msgs/msg/detail/topic_statistics__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'statistics'
#include "rosgraph_monitor_msgs/msg/detail/topic_statistic__traits.hpp"

namespace rosgraph_monitor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const TopicStatistics & msg,
  std::ostream & out)
{
  out << "{";
  // member: timestamp
  {
    out << "timestamp: ";
    to_flow_style_yaml(msg.timestamp, out);
    out << ", ";
  }

  // member: statistics
  {
    if (msg.statistics.size() == 0) {
      out << "statistics: []";
    } else {
      out << "statistics: [";
      size_t pending_items = msg.statistics.size();
      for (auto item : msg.statistics) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TopicStatistics & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp:\n";
    to_block_style_yaml(msg.timestamp, out, indentation + 2);
  }

  // member: statistics
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.statistics.size() == 0) {
      out << "statistics: []\n";
    } else {
      out << "statistics:\n";
      for (auto item : msg.statistics) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TopicStatistics & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rosgraph_monitor_msgs

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rosgraph_monitor_msgs::msg::TopicStatistics>()
{
  return "rosgraph_monitor_msgs::msg::TopicStatistics";
}

template<>
inline const char * name<rosgraph_monitor_msgs::msg::TopicStatistics>()
{
  return "rosgraph_monitor_msgs/msg/TopicStatistics";
}

template<>
struct has_fixed_size<rosgraph_monitor_msgs::msg::TopicStatistics>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rosgraph_monitor_msgs::msg::TopicStatistics>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rosgraph_monitor_msgs::msg::TopicStatistics>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTICS__TRAITS_HPP_
